# Build the manager binary
FROM golang:1.20 as builder
ARG GOPROXY
LABEL project="kanod-clusterdef"
WORKDIR /workspace
# Copy the Go Modules manifests
COPY go.mod go.mod
COPY go.sum go.sum
# cache deps before building and copying source so that we don't need to re-download as much
# and so that source changes don't invalidate our downloaded layer
RUN go mod download

# Copy the go source
COPY main.go main.go
COPY api/ api/
COPY byoh_api/ byoh_api/
COPY controllers/ controllers/
COPY thirdparty/ thirdparty/

# Build
RUN CGO_ENABLED=0 GOOS=linux GOARCH=amd64  go build -a -o manager main.go

# Use distroless as minimal base image to package the manager binary
# Refer to https://github.com/GoogleContainerTools/distroless for more details
FROM gcr.io/distroless/static:nonroot
LABEL project="kanod-clusterdef"
WORKDIR /
COPY --from=builder /workspace/manager .
USER nonroot:nonroot

ENTRYPOINT ["/manager"]
